﻿using System;
using System.Reflection;
using System.Text;

namespace ConsoleApp1
{
    class Program
    {
        static void Main(string[] args)
        {
            byte [] buffer = Encoding.UTF8.GetBytes("한글 테스트입니다.");

            int splitOffset = 8;

            byte[] buf1 = new byte[splitOffset];
            Array.Copy(buffer, buf1, splitOffset);

            byte[] buf2 = new byte[buffer.Length - splitOffset];
            Array.Copy(buffer, splitOffset, buf2, 0, buffer.Length - splitOffset);

            Decoder utf8Decoder = Encoding.UTF8.GetDecoder();
            SendBuffer(utf8Decoder, buf1);

            int bits = GetBits(utf8Decoder);

            utf8Decoder = Encoding.UTF8.GetDecoder();
            SetBits(utf8Decoder, bits);

            SendBuffer(utf8Decoder, buf2);
        }

        private static void SetBits(Decoder utf8Decoder, int bits)
        {
            FieldInfo fi = GetFieldInfo(utf8Decoder);
            fi.SetValue(utf8Decoder, bits);
        }

        private static FieldInfo GetFieldInfo(Decoder decoder)
        {
            return decoder.GetType().GetField("bits", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance);
        }

        private static int GetBits(Decoder utf8Decoder)
        {
            FieldInfo fi = GetFieldInfo(utf8Decoder);
            return (int)fi.GetValue(utf8Decoder);
        }

        private static void SendBuffer(Decoder utf8, byte[] buffer)
        {
            int len = utf8.GetCharCount(buffer, 0, buffer.Length);

            char[] textBuf = new char[len];
            utf8.GetChars(buffer, 0, buffer.Length, textBuf, 0);

            string txt = new string(textBuf);

            Console.WriteLine(txt);
        }
    }
}
