﻿using System;
using System.Collections.Generic;
using System.Text;

namespace ConsoleApp1
{
    class Program
    {
        static void Main(string[] args)
        {
            byte[] buffer = Encoding.UTF8.GetBytes("한글 테스트입니다.");

            int splitOffset = 10;

            for (int i = 0; i <= buffer.Length; i++)
            {
                splitOffset = i;
                byte[] buf1 = new byte[splitOffset];
                Array.Copy(buffer, buf1, splitOffset);

                byte[] buf2 = new byte[buffer.Length - splitOffset];
                Array.Copy(buffer, splitOffset, buf2, 0, buffer.Length - splitOffset);

                byte[] remains = SendBuffer(buf1);

                List<byte> buf = new List<byte>();

                if (remains != null)
                {
                    buf.AddRange(remains);
                }

                buf.AddRange(buf2);

                SendBuffer(buf.ToArray());
            }
        }

        private static byte[] SendBuffer(byte[] buffer)
        {
            if (buffer.Length == 0)
            {
                return null;
            }

            char[] text = Encoding.UTF8.GetChars(buffer);
            char lastChar = text[text.Length - 1];

            byte[] charBytes = Encoding.UTF8.GetBytes(new char[] { lastChar });
            if (EndsWith(buffer, charBytes) == true)
            {
                string txt = new string(text);
                Console.WriteLine(txt);
                return null;
            }
            else
            {
                byte[] remains = null;

                if (text.Length - 2 < 0)
                {
                    remains = new byte[buffer.Length];
                    Array.Copy(buffer, remains, buffer.Length);
                }
                else
                {
                    charBytes = Encoding.UTF8.GetBytes(new char[] { text[text.Length - 2] });
                    remains = GetRemains(buffer, charBytes);
                }

                string txt = new string(text, 0, text.Length - 1);
                Console.WriteLine(txt);

                return remains;
            }
        }

        private static byte[] GetRemains(byte[] buffer, byte[] charBytes)
        {
            List<byte> remains = new List<byte>();

            int lastPos = buffer.Length - 1;

            for (int i = buffer.Length - charBytes.Length; i > 0; i--)
            {
                bool samePos = true;

                for (int j = 0; j < charBytes.Length; j++)
                {
                    if (buffer[i + j] != charBytes[j])
                    {
                        samePos = false;
                        break;
                    }
                }

                if (samePos == true)
                {
                    return remains.ToArray();
                }

                remains.Insert(0, buffer[lastPos--]);
            }

            return remains.ToArray();
        }

        private static bool EndsWith(byte[] buffer, byte[] charBytes)
        {
            if (buffer.Length < charBytes.Length)
            {
                return false;
            }

            for (int i = charBytes.Length - 1; i >= 0; i--)
            {
                if (buffer[buffer.Length - i - 1] != charBytes[i])
                {
                    return false;
                }
            }

            return true;
        }
    }
}
